-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
local steeringWheelLock = 3350

local function onInit()
    electrics.values['4ws2'] = 0
    --get steeringWheelLock to correctly normalize steering value
    if hydros then
        for _, N in pairs (hydros.hydros) do
            --check if it's a steering hydro
            if N.inputSource == "steering_input" then
                steeringWheelLock = N.steeringWheelLock
            end
        end
    end
end

local function updateGFX(dt)
    local steer = electrics.values['steering']/steeringWheelLock --normalize
    local absSteer = math.abs(steer)

    local rws2 = (math.sin(absSteer * 1) * math.cos((absSteer * 1.0))) * 2.7

    rws2 = rws2 * fsign(steer) --Use the sign of the steering input to know the sign of rws2 output

    --print(steer)
    --print(rws2)

    --send the value
    electrics.values['4ws2'] = rws2
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M